/**************************************************************************\
 *
 *  This file is part of the Coin 3D visualization library.
 *  Copyright (C) 1998-2003 by Systems in Motion. All rights reserved.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public License
 *  version 2.1 as published by the Free Software Foundation. See the
 *  file LICENSE.LGPL at the root directory of the distribution for
 *  more details.
 *
 *  If you want to use Coin for applications not compatible with the
 *  LGPL, please contact SIM to acquire a Professional Edition license.
 *
 *  Systems in Motion, Teknobyen, Abels Gate 5, 7030 Trondheim, NORWAY
 *  http://www.sim.no support@sim.no Voice: +47 22114160 Fax: +47 22207097
 *
\**************************************************************************/

#ifndef COIN_SOTEXTURESCALEPOLICY_H
#define COIN_SOTEXTURESCALEPOLICY_H

#include <Inventor/nodes/SoSubNode.h>
#include <Inventor/fields/SoSFEnum.h>
#include <Inventor/elements/SoTextureScalePolicyElement.h>


class COIN_DLL_API SoTextureScalePolicy : public SoNode {
  typedef SoNode inherited;

  SO_NODE_HEADER(SoTextureScalePolicy);
  
public:
  static void initClass(void);
  SoTextureScalePolicy(void);

  enum Policy {
    USE_TEXTURE_QUALITY = SoTextureScalePolicyElement::USE_TEXTURE_QUALITY,
    SCALE_DOWN = SoTextureScalePolicyElement::SCALE_DOWN,
    SCALE_UP = SoTextureScalePolicyElement::SCALE_UP,
    DONT_SCALE = SoTextureScalePolicyElement::DONT_SCALE
  };

  SoSFEnum policy;

  virtual void GLRender(SoGLRenderAction * action);

protected:
  virtual ~SoTextureScalePolicy();
};

#endif // !COIN_SOTEXTURESCALEPOLICY_H
