/**************************************************************************\
 *
 *  This file is part of the Coin 3D visualization library.
 *  Copyright (C) 1998-2003 by Systems in Motion. All rights reserved.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public License
 *  version 2.1 as published by the Free Software Foundation. See the
 *  file LICENSE.LGPL at the root directory of the distribution for
 *  more details.
 *
 *  If you want to use Coin for applications not compatible with the
 *  LGPL, please contact SIM to acquire a Professional Edition license.
 *
 *  Systems in Motion, Teknobyen, Abels Gate 5, 7030 Trondheim, NORWAY
 *  http://www.sim.no support@sim.no Voice: +47 22114160 Fax: +47 22207097
 *
\**************************************************************************/

#include "SoAnnotation.cpp"
#include "SoAntiSquish.cpp"
#include "SoArray.cpp"
#include "SoAsciiText.cpp"
#include "SoBaseColor.cpp"
#include "SoBlinker.cpp"
#include "SoCallback.cpp"
#include "SoCamera.cpp"
#include "SoClipPlane.cpp"
#include "SoColorIndex.cpp"
#include "SoComplexity.cpp"
#include "SoCone.cpp"
#include "SoCoordinate3.cpp"
#include "SoCoordinate4.cpp"
#include "SoCube.cpp"
#include "SoCylinder.cpp"
#include "SoDirectionalLight.cpp"
#include "SoDrawStyle.cpp"
#include "SoEnvironment.cpp"
#include "SoEventCallback.cpp"
#include "SoExtSelection.cpp"
#include "SoFaceSet.cpp"
#include "SoFile.cpp"
#include "SoFont.cpp"
#include "SoFontStyle.cpp"
#include "SoGroup.cpp"
#include "SoImage.cpp"
#include "SoIndexedFaceSet.cpp"
#include "SoIndexedLineSet.cpp"
#include "SoIndexedNurbsCurve.cpp"
#include "SoIndexedNurbsSurface.cpp"
#include "SoIndexedShape.cpp"
#include "SoIndexedTriangleStripSet.cpp"
#include "SoInfo.cpp"
#include "SoLOD.cpp"
#include "SoLabel.cpp"
#include "SoLevelOfDetail.cpp"
#include "SoLight.cpp"
#include "SoLightModel.cpp"
#include "SoLineSet.cpp"
#include "SoLinearProfile.cpp"
#include "SoLocateHighlight.cpp"
#include "SoMarkerSet.cpp"
#include "SoMaterial.cpp"
#include "SoMaterialBinding.cpp"
#include "SoMatrixTransform.cpp"
#include "SoMultipleCopy.cpp"
#include "SoNode.cpp"
#include "SoNonIndexedShape.cpp"
#include "SoNormal.cpp"
#include "SoNormalBinding.cpp"
#include "SoNurbsCurve.cpp"
#include "SoNurbsProfile.cpp"
#include "SoNurbsSurface.cpp"
#include "SoOrthographicCamera.cpp"
#include "SoPackedColor.cpp"
#include "SoPathSwitch.cpp"
#include "SoPendulum.cpp"
#include "SoPerspectiveCamera.cpp"
#include "SoPickStyle.cpp"
#include "SoPointLight.cpp"
#include "SoPointSet.cpp"
#include "SoPolygonOffset.cpp"
#include "SoProfile.cpp"
#include "SoProfileCoordinate2.cpp"
#include "SoProfileCoordinate3.cpp"
#include "SoQuadMesh.cpp"
#include "SoResetTransform.cpp"
#include "SoRotation.cpp"
#include "SoRotationXYZ.cpp"
#include "SoRotor.cpp"
#include "SoScale.cpp"
#include "SoSelection.cpp"
#include "SoSeparator.cpp"
#include "SoShape.cpp"
#include "SoShapeHints.cpp"
#include "SoShuttle.cpp"
#include "SoSphere.cpp"
#include "SoSpotLight.cpp"
#include "SoSurroundScale.cpp"
#include "SoSwitch.cpp"
#include "SoText2.cpp"
#include "SoText3.cpp"
#include "SoTexture2.cpp"
#include "SoTexture2Transform.cpp"
#include "SoTextureCoordinate2.cpp"
#include "SoTextureCoordinateBinding.cpp"
#include "SoTextureCoordinateDefault.cpp"
#include "SoTextureCoordinateEnvironment.cpp"
#include "SoTextureCoordinateFunction.cpp"
#include "SoTextureCoordinatePlane.cpp"
#include "SoTextureScalePolicy.cpp"
#include "SoTransform.cpp"
#include "SoTransformSeparator.cpp"
#include "SoTransformation.cpp"
#include "SoTranslation.cpp"
#include "SoTriangleStripSet.cpp"
#include "SoUnits.cpp"
#include "SoUnknownNode.cpp"
#include "SoVertexProperty.cpp"
#include "SoVertexShape.cpp"
#include "SoWWWAnchor.cpp"
#include "SoWWWInline.cpp"
#include "soshape_bigtexture.cpp"
#include "soshape_primdata.cpp"
#include "soshape_trianglesort.cpp"
